function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// react
import * as React from "react";
import PropTypes from "prop-types"; // kendo component

import { ComboBox } from "@progress/kendo-react-dropdowns"; // share component

import FilterListShow from "view/FEE/common/ListShow/FilterListShow";
import FeeDialog from "./FeeDialog";
const Style = {
  combobox: {
    width: '90%',
    color: '#212529'
  }
};

class PopupComboBox extends React.Component {
  constructor(...args) {
    super(...args);
    this.state = {
      data: this.props.data ? [...this.props.data] : [],
      value: null,
      showPopup: false
    };

    this.handleOpen = event => {
      this.props.onOpen && this.props.onOpen(event);
      this.setState({
        showPopup: true
      });
    };

    this.handleChange = event => {
      const {
        dataItemKey,
        textField
      } = this.props;
      const newValue = {
        code: undefined,
        show: '請選擇',
        [dataItemKey]: undefined,
        [textField]: '請選擇'
      };
      this.props.onSelect && this.props.onSelect(event, newValue);
      this.setState({
        value: undefined
      });
    };

    this.handleSelect = cellProps => event => {
      const {
        dataItemKey,
        textField
      } = this.props;
      const value = cellProps.dataItem;
      const newValue = {
        code: value[dataItemKey],
        show: value[textField],
        ...value
      };
      this.props.onSelect && this.props.onSelect(event, newValue);
      this.setState({
        showPopup: false,
        value: cellProps.dataItem
      });
    };

    this.handlePopupOpen = () => this.setState({
      showPopup: true
    });

    this.handlePopupClose = () => this.setState({
      showPopup: false
    });

    this.renderContent = () => {
      // value.key 有值時 , 將 key 與 name 值 , 放入 filter 中
      const filter = this.state.value && this.state.value[this.props.dataItemKey] && {
        logic: "and",
        filters: [{
          field: this.props.dataItemKey,
          operator: "contains",
          value: this.state.value[this.props.dataItemKey]
        }]
      }; // 將 props.columns 當物件取出

      const columns = this.props.columns;
      return React.createElement(React.Fragment, null, React.createElement("h3", null, "\u7BE9\u9078\u529F\u80FD:\u53EA\u7BE9\u9078\u51FA\u67E5\u8A62\u9801\u5F8C\u7684\u8CC7\u6599"), React.createElement(FilterListShow, {
        pageable: true,
        data: this.props.data,
        title: `${this.props.title}清單`,
        filter: filter,
        gridRowButtons: [{
          name: '選擇',
          onClick: this.handleSelect
        }]
      }, // 取得 columns 物件中的 children
      columns.props.children));
    };
  }

  componentWillMount() {
    // 設定預設值
    this.setState({
      filter: this.props.defaultValue,
      value: this.props.defaultValue
    });
  }

  componentDidMount() {
    // 讓使用者不能修改 input 值
    this.combobox._input.readOnly = true;
  }

  // 將下拉選單 , 改成彈跳視窗
  render() {
    return React.createElement(React.Fragment, null, React.createElement("div", {
      onClick: this.handlePopupOpen
    }, React.createElement(ComboBox, _extends({
      ref: component => this.combobox = component,
      textField: "show",
      dataItemKey: "code",
      placeholder: "\u8ACB\u9078\u64C7"
    }, this.props, {
      style: { ...Style.combobox,
        ...this.props.style
      },
      opened: false,
      value: this.state.value,
      data: [] // 此 data 不重要 , 因為下拉選單不顯示
      ,
      onOpen: this.handleOpen,
      onChange: this.handleChange
    }))), this.state.showPopup ? React.createElement(FeeDialog, {
      handleClose: this.handlePopupClose,
      title: `選擇${this.props.title}`,
      buttons: [{
        name: '關閉',
        onClick: this.handlePopupClose
      }],
      content: this.renderContent()
    }) : '');
  }

}

PopupComboBox.propTypes = {
  data: PropTypes.array,
  onSelect: PropTypes.func,
  columns: PropTypes.element.isRequired
};
export default PopupComboBox;